Index: src_parallel/readageclasses.f90
===================================================================
--- src_parallel/readageclasses.f90	(revision 3eed2e63a5b06d8d7013ec82d89123c0551cc037)
+++ src_parallel/readageclasses.f90	(revision ff050cd28a8d909666c5efc0c10afc7463e6add4)
@@ -28,6 +28,7 @@
   !                                                                            *
   !     Author: A. Stohl                                                       *
-  !                                                                            *
   !     20 March 2000                                                          *
+  !     HSO, 14 August 2013
+  !     Added optional namelist input
   !                                                                            *
   !*****************************************************************************
@@ -46,9 +47,17 @@
   integer :: i
 
+  ! namelist help variables
+  integer :: readerror
+
+  ! namelist declaration
+  namelist /ageclass/ &
+    nageclass, &
+    lage
+
+  nageclass=-1 ! preset to negative value to identify failed namelist input
 
   ! If age spectra calculation is switched off, set number of age classes
   ! to 1 and maximum age to a large number
   !**********************************************************************
-
 
   if (lagespectra.ne.1) then
@@ -57,5 +66,4 @@
     return
   endif
-
 
   ! If age spectra claculation is switched on,
@@ -66,9 +74,20 @@
        status='old',err=999)
 
-  do i=1,13
-    read(unitageclasses,*)
-  end do
-  read(unitageclasses,*) nageclass
+  ! try to read in as a namelist
+  read(unitageclasses,ageclass,iostat=readerror)
 
+  if ((nageclass.lt.0).or.(readerror.ne.0)) then
+    rewind(unitageclasses)
+    do i=1,13
+      read(unitageclasses,*)
+    end do
+    read(unitageclasses,*) nageclass
+    read(unitageclasses,*) lage(1)
+    do i=2,nageclass
+      read(unitageclasses,*) lage(i)
+    end do
+  endif
+
+  close(unitageclasses)
 
   if (nageclass.gt.maxageclass) then
@@ -81,5 +100,4 @@
   endif
 
-  read(unitageclasses,*) lage(1)
   if (lage(1).le.0) then
     write(*,*) ' #### FLEXPART MODEL ERROR! AGE OF FIRST      #### '
@@ -90,5 +108,4 @@
 
   do i=2,nageclass
-    read(unitageclasses,*) lage(i)
     if (lage(i).le.lage(i-1)) then
       write(*,*) ' #### FLEXPART MODEL ERROR! AGE CLASSES     #### '
Index: src_parallel/readavailable.f90
===================================================================
--- src_parallel/readavailable.f90	(revision 3eed2e63a5b06d8d7013ec82d89123c0551cc037)
+++ src_parallel/readavailable.f90	(revision ff050cd28a8d909666c5efc0c10afc7463e6add4)
@@ -46,7 +46,6 @@
   ! numbwf               actual number of wind fields                          *
   ! wfname(maxwf)        file names of needed wind fields                      *
-  ! wfspec(maxwf)        file specifications of wind fields (e.g., if on disc) *
   ! wftime(maxwf) [s]times of wind fields relative to beginning time           *
-  ! wfname1,wfspec1,wftime1 = same as above, but only local (help variables)   *
+  ! wfname1,wftime1 = same as above, but only local (help variables)   *
   !                                                                            *
   ! Constants:                                                                 *
@@ -64,7 +63,6 @@
   integer :: wftime1n(maxnests,maxwf),wftimen(maxnests,maxwf)
   real(kind=dp) :: juldate,jul,beg,end
-  character(len=255) :: fname,spec,wfname1(maxwf),wfspec1(maxwf)
+  character(len=255) :: fname,spec,wfname1(maxwf)
   character(len=255) :: wfname1n(maxnests,maxwf)
-  character(len=40) :: wfspec1n(maxnests,maxwf)
 
 
@@ -109,5 +107,4 @@
 
       wfname1(numbwf)=fname(1:index(fname,' '))
-      wfspec1(numbwf)=spec
       wftime1(numbwf)=nint((jul-bdate)*86400._dp)
     endif
@@ -146,5 +143,4 @@
 
         wfname1n(k,numbwfn(k))=fname
-        wfspec1n(k,numbwfn(k))=spec
         wftime1n(k,numbwfn(k))=nint((jul-bdate)*86400._dp)
       endif
@@ -205,5 +201,4 @@
     do i=1,numbwf
       wfname(i)=wfname1(i)
-      wfspec(i)=wfspec1(i)
       wftime(i)=wftime1(i)
     end do
@@ -211,5 +206,4 @@
       do i=1,numbwfn(k)
         wfnamen(k,i)=wfname1n(k,i)
-        wfspecn(k,i)=wfspec1n(k,i)
         wftimen(k,i)=wftime1n(k,i)
       end do
@@ -218,5 +212,4 @@
     do i=1,numbwf
       wfname(numbwf-i+1)=wfname1(i)
-      wfspec(numbwf-i+1)=wfspec1(i)
       wftime(numbwf-i+1)=wftime1(i)
     end do
@@ -224,5 +217,4 @@
       do i=1,numbwfn(k)
         wfnamen(k,numbwfn(k)-i+1)=wfname1n(k,i)
-        wfspecn(k,numbwfn(k)-i+1)=wfspec1n(k,i)
         wftimen(k,numbwfn(k)-i+1)=wftime1n(k,i)
       end do
Index: src_parallel/readcommand.f90
===================================================================
--- src_parallel/readcommand.f90	(revision 3eed2e63a5b06d8d7013ec82d89123c0551cc037)
+++ src_parallel/readcommand.f90	(revision ff050cd28a8d909666c5efc0c10afc7463e6add4)
@@ -27,6 +27,7 @@
   !                                                                            *
   !     Author: A. Stohl                                                       *
-  !                                                                            *
   !     18 May 1996                                                            *
+  !     HSO, 14 August 2013
+  !     Added optional namelist input
   !                                                                            *
   !*****************************************************************************
@@ -83,4 +84,5 @@
   integer :: readerror
 
+  ! declaration of namelist
   namelist /command/ &
     ldirect, &
@@ -96,4 +98,5 @@
     iout, &
     ipout, &
+    lnetcdfout, &
     lsubgrid, &
     lconvection, &
@@ -109,9 +112,9 @@
     linit_cond
 
-  ! Presetting namelist command
+  ! Presetting the namelist command
   ldirect=0
-  ibdate=20000101
+  ibdate=0
   ibtime=0
-  iedate=20000102
+  iedate=0
   ietime=0
   loutstep=10800
@@ -124,4 +127,5 @@
   iout=3
   ipout=0
+  lnetcdfout=0
   lsubgrid=1
   lconvection=1
@@ -141,22 +145,14 @@
   !**************************************************************************
   open(unitcommand,file=path(1)(1:length(1))//'COMMAND',status='old', &
-         form='formatted',iostat=readerror)
-  ! If fail, check if file does not exist
-  if (readerror.ne.0) then
-
-    print*,'***ERROR: file COMMAND not found. Check your pathnames file.'
-    stop
-
-  endif
-
+         err=999)
+
+  ! try namelist input
   read(unitcommand,command,iostat=readerror)
-  close(unitcommand)
 
   ! If error in namelist format, try to open with old input code
   ! Failsafe detection with ldirect initial value change
-  if ((readerror.ne.0).or.(ldirect.ne.0)) then
-
-    open(unitcommand,file=path(1)(1:length(1))//'COMMAND',status='old', &
-         err=999)
+  if ((readerror.ne.0).or.(ldirect.eq.0)) then
+
+    rewind(unitcommand)
 
     ! Check the format of the COMMAND file (either in free format,
@@ -346,11 +342,10 @@
   endif
 
-!  check for netcdf output switch
-  lncdfout = .false.
+!  check for netcdf output switch (use for non-namelist input only!)
   if (iout.ge.8) then
-     lncdfout = .true.
+     lnetcdfout = 1
      iout = iout - 8
 #ifndef NETCDF_OUTPUT
-     print*,'ERROR: netcdf output not activated during compile time'
+     print*,'ERROR: netcdf output not activated during compile time but used in COMMAND file!'
 #endif
   endif
Index: src_parallel/readoutgrid.f90
===================================================================
--- src_parallel/readoutgrid.f90	(revision 3eed2e63a5b06d8d7013ec82d89123c0551cc037)
+++ src_parallel/readoutgrid.f90	(revision ff050cd28a8d909666c5efc0c10afc7463e6add4)
@@ -53,5 +53,19 @@
   real,parameter :: eps=1.e-4
 
-
+  ! namelist variables
+  integer, parameter :: maxoutlev=500
+  real :: outheights(maxoutlev)
+  integer :: readerror
+
+  ! declare namelist
+  namelist /outgrid/ &
+    outlon0,outlat0, &
+    numxgrid,numygrid, &
+    dxout,dyout, &
+    outheights
+
+  ! helps identifying failed namelist input
+  dxout=-1.0
+  outheights=-1.0
 
   ! Open the OUTGRID file and read output grid specifications
@@ -61,24 +75,32 @@
        err=999)
 
-
-  call skplin(5,unitoutgrid)
-
-
-  ! 1.  Read horizontal grid specifications
-  !****************************************
-
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f11.4)') outlon0
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f11.4)') outlat0
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,i5)') numxgrid
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,i5)') numygrid
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f12.5)') dxout
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f12.5)') dyout
-
+  ! try namelist input
+  read(unitoutgrid,outgrid,iostat=readerror)
+
+
+  if ((dxout.le.0).or.(readerror.ne.0)) then
+
+    readerror=1
+
+    rewind(unitoutgrid)
+    call skplin(5,unitoutgrid)
+
+    ! 1.  Read horizontal grid specifications
+    !****************************************
+
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f11.4)') outlon0
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f11.4)') outlat0
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,i5)') numxgrid
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,i5)') numygrid
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f12.5)') dxout
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f12.5)') dyout
+
+  endif
 
   ! Check validity of output grid (shall be within model domain)
@@ -102,6 +124,8 @@
   ! 2. Count Vertical levels of output grid
   !****************************************
-  j=0
-100   j=j+1
+
+  if (readerror.ne.0) then
+    j=0
+100 j=j+1
     do i=1,3
       read(unitoutgrid,*,end=99)
@@ -110,31 +134,42 @@
     if (outhelp.eq.0.) goto 99
     goto 100
-99   numzgrid=j-1
-
-    allocate(outheight(numzgrid) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-    allocate(outheighthalf(numzgrid) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-
-
-  rewind(unitoutgrid)
-  call skplin(29,unitoutgrid)
+99  numzgrid=j-1
+  else
+    do i=1,maxoutlev
+      if (outheights(i).lt.0) exit
+    end do
+    numzgrid=i-1
+  end if
+
+  allocate(outheight(numzgrid),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate outheight'
+  allocate(outheighthalf(numzgrid),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate outheighthalf'
 
   ! 2. Vertical levels of output grid
   !**********************************
 
-  j=0
-1000   j=j+1
-    do i=1,3
-      read(unitoutgrid,*,end=990)
-    end do
-    read(unitoutgrid,'(4x,f7.1)',end=990) outhelp
-    if (outhelp.eq.0.) goto 99
-    outheight(j)=outhelp
-    goto 1000
-990   numzgrid=j-1
-
+  if (readerror.ne.0) then
+
+    rewind(unitoutgrid)
+    call skplin(29,unitoutgrid)
+
+    do j=1,numzgrid
+      do i=1,3
+        read(unitoutgrid,*)
+      end do
+      read(unitoutgrid,'(4x,f7.1)') outhelp
+      outheight(j)=outhelp
+    end do
+
+  else
+
+    do j=1,numzgrid
+      outheight(j)=outheights(j)
+    end do
+
+  endif
+
+  close(unitoutgrid)
 
   ! Check whether vertical levels are specified in ascending order
@@ -158,28 +193,21 @@
   end do
 
-
   xoutshift=xlon0-outlon0
   youtshift=ylat0-outlat0
-  close(unitoutgrid)
-
-    allocate(oroout(0:numxgrid-1,0:numygrid-1) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-    allocate(area(0:numxgrid-1,0:numygrid-1) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-    allocate(volume(0:numxgrid-1,0:numygrid-1,numzgrid) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-    allocate(areaeast(0:numxgrid-1,0:numygrid-1,numzgrid) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-    allocate(areanorth(0:numxgrid-1,0:numygrid-1,numzgrid) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
+
+  allocate(oroout(0:numxgrid-1,0:numygrid-1),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate oroout'
+  allocate(area(0:numxgrid-1,0:numygrid-1),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate area'
+  allocate(volume(0:numxgrid-1,0:numygrid-1,numzgrid),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate volume'
+  allocate(areaeast(0:numxgrid-1,0:numygrid-1,numzgrid),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate areaeast'
+  allocate(areanorth(0:numxgrid-1,0:numygrid-1,numzgrid),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate areanorth'
   return
 
 
-999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "OUTGRID"    #### '
+999 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "OUTGRID"    #### '
   write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
   write(*,*) ' #### xxx/flexpart/options                    #### '
Index: src_parallel/readoutgrid_nest.f90
===================================================================
--- src_parallel/readoutgrid_nest.f90	(revision 3eed2e63a5b06d8d7013ec82d89123c0551cc037)
+++ src_parallel/readoutgrid_nest.f90	(revision ff050cd28a8d909666c5efc0c10afc7463e6add4)
@@ -53,5 +53,14 @@
   real,parameter :: eps=1.e-4
 
+  integer :: readerror
 
+  ! declare namelist
+  namelist /outgridn/ &
+    outlon0n,outlat0n, &
+    numxgridn,numygridn, &
+    dxoutn,dyoutn
+
+  ! helps identifying failed namelist input
+  dxoutn=-1.0
 
   ! Open the OUTGRID file and read output grid specifications
@@ -61,34 +70,38 @@
        status='old',err=999)
 
+  ! try namelist input
+  read(unitoutgrid,outgridn,iostat=readerror)
 
-  call skplin(5,unitoutgrid)
+  if ((dxoutn.le.0).or.(readerror.ne.0)) then
 
+    rewind(unitoutgrid)
+    call skplin(5,unitoutgrid)
 
-  ! 1.  Read horizontal grid specifications
-  !****************************************
+    ! 1.  Read horizontal grid specifications
+    !****************************************
 
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f11.4)') outlon0n
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f11.4)') outlat0n
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,i5)') numxgridn
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,i5)') numygridn
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f12.5)') dxoutn
-  call skplin(3,unitoutgrid)
-  read(unitoutgrid,'(4x,f12.5)') dyoutn
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f11.4)') outlon0n
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f11.4)') outlat0n
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,i5)') numxgridn
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,i5)') numygridn
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f12.5)') dxoutn
+    call skplin(3,unitoutgrid)
+    read(unitoutgrid,'(4x,f12.5)') dyoutn
 
+  endif
 
-    allocate(orooutn(0:numxgridn-1,0:numygridn-1) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-    allocate(arean(0:numxgridn-1,0:numygridn-1) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
-    allocate(volumen(0:numxgridn-1,0:numygridn-1,numzgrid) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate outh'
+  close(unitoutgrid)
+
+  allocate(orooutn(0:numxgridn-1,0:numygridn-1),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate orooutn'
+  allocate(arean(0:numxgridn-1,0:numygridn-1),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate arean'
+  allocate(volumen(0:numxgridn-1,0:numygridn-1,numzgrid),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate volumen'
 
   ! Check validity of output grid (shall be within model domain)
@@ -110,9 +123,7 @@
   xoutshiftn=xlon0-outlon0n
   youtshiftn=ylat0-outlat0n
-  close(unitoutgrid)
   return
 
-
-999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE OUTGRID_NEST #### '
+999 write(*,*) ' #### FLEXPART MODEL ERROR! FILE OUTGRID_NEST #### '
   write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
   write(*,*) ' #### xxx/flexpart/options                    #### '
Index: src_parallel/readreceptors.f90
===================================================================
--- src_parallel/readreceptors.f90	(revision 3eed2e63a5b06d8d7013ec82d89123c0551cc037)
+++ src_parallel/readreceptors.f90	(revision ff050cd28a8d909666c5efc0c10afc7463e6add4)
@@ -27,6 +27,7 @@
   !                                                                            *
   !     Author: A. Stohl                                                       *
-  !                                                                            *
   !     1 August 1996                                                          *
+  !     HSO, 14 August 2013
+  !     Added optional namelist input
   !                                                                            *
   !*****************************************************************************
@@ -51,4 +52,12 @@
   character(len=16) :: receptor
 
+  integer :: readerror
+  real :: lon,lat   ! for namelist input, lon/lat are used instead of x,y
+
+  ! declare namelist
+  namelist /receptors/ &
+    receptor, lon, lat
+
+  lon=-999.9
 
   ! For backward runs, do not allow receptor output. Thus, set number of receptors to zero
@@ -67,12 +76,17 @@
        status='old',err=999)
 
-  call skplin(5,unitreceptor)
+  ! try namelist input
+  read(unitreceptor,receptors,iostat=readerror)
 
+  rewind(unitreceptor)
+  if ((lon.lt.-900).or.(readerror.ne.0)) then
 
-  ! Read the names and coordinates of the receptors
-  !************************************************
+    call skplin(5,unitreceptor)
 
-  j=0
-100   j=j+1
+    ! Read the names and coordinates of the receptors
+    !************************************************
+
+    j=0
+100 j=j+1
     read(unitreceptor,*,end=99)
     read(unitreceptor,*,end=99)
@@ -89,8 +103,8 @@
     endif
     if (j.gt.maxreceptor) then
-    write(*,*) ' #### FLEXPART MODEL ERROR! TOO MANY RECEPTOR #### '
-    write(*,*) ' #### POINTS ARE GIVEN.                       #### '
-    write(*,*) ' #### MAXIMUM NUMBER IS ',maxreceptor,'       #### '
-    write(*,*) ' #### PLEASE MAKE CHANGES IN FILE RECEPTORS   #### '
+      write(*,*) ' #### FLEXPART MODEL ERROR! TOO MANY RECEPTOR #### '
+      write(*,*) ' #### POINTS ARE GIVEN.                       #### '
+      write(*,*) ' #### MAXIMUM NUMBER IS ',maxreceptor,'       #### '
+      write(*,*) ' #### PLEASE MAKE CHANGES IN FILE RECEPTORS   #### '
     endif
     receptorname(j)=receptor
@@ -102,10 +116,40 @@
     goto 100
 
-99   numreceptor=j-1
+99  numreceptor=j-1
+
+  else ! continue with namelist input
+
+    j=0
+    do while (readerror.eq.0)
+      j=j+1
+      lon=-999.9
+      read(unitreceptor,receptors,iostat=readerror)
+      if ((lon.lt.-900).or.(readerror.ne.0)) then
+        readerror=1
+      else
+        if (j.gt.maxreceptor) then
+          write(*,*) ' #### FLEXPART MODEL ERROR! TOO MANY RECEPTOR #### '
+          write(*,*) ' #### POINTS ARE GIVEN.                       #### '
+          write(*,*) ' #### MAXIMUM NUMBER IS ',maxreceptor,'       #### '
+          write(*,*) ' #### PLEASE MAKE CHANGES IN FILE RECEPTORS   #### '
+        endif
+        receptorname(j)=receptor
+        xreceptor(j)=(lon-xlon0)/dx       ! transform to grid coordinates
+        yreceptor(j)=(lat-ylat0)/dy
+        xm=r_earth*cos(lat*pi/180.)*dx/180.*pi
+        ym=r_earth*dy/180.*pi
+        receptorarea(j)=xm*ym
+      endif
+    end do
+    numreceptor=j-1
+
+  endif
+
+
   close(unitreceptor)
   return
 
 
-999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE "RECEPTORS"  #### '
+999 write(*,*) ' #### FLEXPART MODEL ERROR! FILE "RECEPTORS"  #### '
   write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
   write(*,'(a)') path(1)(1:length(1))
Index: src_parallel/readreleases.f90
===================================================================
--- src_parallel/readreleases.f90	(revision 3eed2e63a5b06d8d7013ec82d89123c0551cc037)
+++ src_parallel/readreleases.f90	(revision ff050cd28a8d909666c5efc0c10afc7463e6add4)
@@ -33,4 +33,6 @@
   !     Update: 29 January 2001                                                *
   !     Release altitude can be either in magl or masl                         *
+  !     HSO, 12 August 2013
+  !     Added optional namelist input
   !                                                                            *
   !*****************************************************************************
@@ -67,5 +69,6 @@
   implicit none
 
-  integer :: numpartmax,i,j,id1,it1,id2,it2,specnum_rel,idum,stat
+  integer :: numpartmax,i,j,id1,it1,id2,it2,idum,stat
+  integer :: specnum_rel(maxspec)
   real :: vsh(ni),fracth(ni),schmih(ni),releaserate,xdum,cun
   real(kind=dp) :: jul1,jul2,juldate
@@ -73,8 +76,46 @@
   logical :: old
 
+  ! help variables for namelist reading
+  integer :: numpoints, parts, readerror
+  integer*2 :: zkind
+  integer :: idate1, itime1, idate2, itime2
+  real :: lon1,lon2,lat1,lat2,z1,z2,mass(nspec)
+  character*40 :: comment
+
+  ! declare namelists
+  namelist /releases_ctrl/ &
+    nspec, &
+    specnum_rel
+
+  namelist /release/ &
+    idate1, itime1, &
+    idate2, itime2, &
+    lon1, lon2, &
+    lat1, lat2, &
+    z1, z2, &
+    zkind, &
+    mass, &
+    parts, &
+    comment
+
+  numpoint=0
+
+  ! presetting namelist releases_ctrl
+  nspec = -1  ! use negative value to determine failed namelist input
+  specnum_rel(1) = 0
+
   !sec, read release to find how many releasepoints should be allocated
-
   open(unitreleases,file=path(1)(1:length(1))//'RELEASES',status='old', &
        err=999)
+
+  ! check if namelist input provided
+  read(unitreleases,releases_ctrl,iostat=readerror)
+
+  if ((readerror.ne.0).or.(nspec.lt.0)) then
+
+  ! no namelist format, close file and allow reopening in old format
+  rewind(unitreleases)
+
+  readerror=1 ! indicates old format
 
   ! Check the format of the RELEASES file (either in free format,
@@ -93,19 +134,15 @@
   rewind(unitreleases)
 
-
   ! Skip first 11 lines (file header)
   !**********************************
 
   call skplin(11,unitreleases)
-
-
   read(unitreleases,*,err=998) nspec
   if (old) call skplin(2,unitreleases)
   do i=1,nspec
-    read(unitreleases,*,err=998) specnum_rel
+    read(unitreleases,*,err=998) specnum_rel(1)
     if (old) call skplin(2,unitreleases)
   end do
 
-  numpoint=0
 100   numpoint=numpoint+1
   read(unitreleases,*,end=25)
@@ -142,50 +179,54 @@
 25   numpoint=numpoint-1
 
+  else 
+    readerror=0
+    do while (readerror.eq.0) 
+      idate1=-1
+      read(unitreleases,release,iostat=readerror)
+      if ((idate1.lt.0).or.(readerror.ne.0)) then
+        readerror=1
+      else
+        numpoint=numpoint+1
+      endif
+    end do
+    readerror=0
+  endif ! if namelist input
+
+  rewind(unitreleases)
+
   !allocate memory for numpoint releaspoint
-    allocate(ireleasestart(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(ireleaseend(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(xpoint1(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(xpoint2(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(ypoint1(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(ypoint2(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(zpoint1(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(zpoint2(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(kindz(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(xmass(numpoint,maxspec) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(rho_rel(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(npart(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-    allocate(xmasssave(numpoint) &
-         ,stat=stat)
-    if (stat.ne.0) write(*,*)'ERROR: could not allocate RELEASPOINT'
-
-   write (*,*) ' Releasepoints allocated: ', numpoint
-
-   do i=1,numpoint
-     xmasssave(i)=0.
-   end do
+  allocate(ireleasestart(numpoint),stat=stat)
+       
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(ireleaseend(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(xpoint1(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(xpoint2(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(ypoint1(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(ypoint2(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(zpoint1(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(zpoint2(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(kindz(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(xmass(numpoint,maxspec),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(rho_rel(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(npart(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+  allocate(xmasssave(numpoint),stat=stat)
+  if (stat.ne.0) write(*,*)'ERROR: could not allocate releasepoint'
+
+  write (*,*) numpoint,' releasepoints allocated.'
+
+  do i=1,numpoint
+    xmasssave(i)=0.
+  end do
 
   !now save the information
@@ -198,23 +239,25 @@
   end do
 
-  rewind(unitreleases)
-
-
+  if (readerror.ne.0) then
   ! Skip first 11 lines (file header)
   !**********************************
 
-  call skplin(11,unitreleases)
-
+    call skplin(11,unitreleases)
 
   ! Assign species-specific parameters needed for physical processes
   !*************************************************************************
 
-  read(unitreleases,*,err=998) nspec
-  if (nspec.gt.maxspec) goto 994
-  if (old) call skplin(2,unitreleases)
+    read(unitreleases,*,err=998) nspec
+    if (nspec.gt.maxspec) goto 994
+  if (old) call skplin(2,unitreleases)
+  endif
   do i=1,nspec
-    read(unitreleases,*,err=998) specnum_rel
-    if (old) call skplin(2,unitreleases)
-    call readspecies(specnum_rel,i)
+    if (readerror.ne.0) then
+      read(unitreleases,*,err=998) specnum_rel(1)
+      if (old) call skplin(2,unitreleases)
+      call readspecies(specnum_rel(1),i)
+    else
+      call readspecies(specnum_rel(i),i)
+    endif
 
   ! For backward runs, only 1 species is allowed
@@ -301,9 +344,37 @@
   ! Read specifications for each release point
   !*******************************************
-
+  numpoints=numpoint
   numpoint=0
   numpartmax=0
   releaserate=0.
 1000   numpoint=numpoint+1
+
+  if (readerror.eq.0) then ! reading namelist format
+
+  if (numpoint.gt.numpoints) goto 250
+  zkind = 1
+  mass = 0
+  parts = 0
+  comment = ' '
+  read(unitreleases,release,iostat=readerror)
+  id1=idate1
+  it1=itime1
+  id2=idate2
+  it2=itime2
+  xpoint1(numpoint)=lon1
+  xpoint2(numpoint)=lon2
+  ypoint1(numpoint)=lat1
+  ypoint2(numpoint)=lat2
+  zpoint1(numpoint)=z1
+  zpoint2(numpoint)=z2
+  kindz(numpoint)=zkind
+  do i=1,nspec
+    xmass(numpoint,i)=mass(i)
+  end do
+  npart(numpoint)=parts
+  compoint(min(1001,numpoint))=comment
+
+  else
+
   read(unitreleases,*,end=250)
   read(unitreleases,*,err=998,end=250) id1,it1
@@ -347,4 +418,5 @@
   endif
 
+  endif ! if namelist format
 
   ! If a release point contains no particles, stop and issue error message
